package main

import (
	"log"
	"net/http"

	"git.nxdomain.nl/mattijs/pathway"
)

var (
	// variables to set during build-time
	debugging = ""
	version   = "0.0-undefined"
	buildtime = "0000-00-00T00:00:00+0000"
)

func okHandler(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusOK)
	w.Write([]byte("ok"))
}

func emptyHandler(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusOK)
}

func main() {
	info("pathway version:%s buildtime:%s", version, buildtime)

	http.HandleFunc("/health", okHandler)
	http.HandleFunc("/favicon.ico", emptyHandler)
	http.HandleFunc("/robots.txt", emptyHandler)
	http.HandleFunc("/", pathway.pathHandler)

	err := http.ListenAndServe(":8080", nil)
	if err != nil {
		info("%s", err.Error())
	}
}

func info(msg string, args ...interface{}) {
	log.Printf("INFO | "+msg, args...)
}

func debug(msg string, args ...interface{}) {
	if len(debugging) > 0 {
		log.Printf("DEBUG | "+msg, args...)
	}
}
